Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/CheckBoxMultipleSelectionRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/CheckBoxMultipleSelectionRule.java	(revision 1918)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/CheckBoxMultipleSelectionRule.java	(revision 1918)
@@ -0,0 +1,245 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.usability;
+
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+
+import de.ugoe.cs.autoquest.eventcore.guimodel.ICheckBox;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IGUIElement;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.DefaultTaskTraversingVisitor;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTask;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IMarkingTemporalRelationship;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IStructuringTemporalRelationship;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.TaskMetric;
+
+/**
+ * TODO comment
+ * 
+ * @version $Revision: $ $Date: 16.07.2012$
+ * @author 2012, last modified by $Author: pharms$
+ */
+public class CheckBoxMultipleSelectionRule implements UsabilityEvaluationRule {
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.usability.UsabilityEvaluationRule#evaluate(TaskTree)
+     */
+    @Override
+    public UsabilityEvaluationResult evaluate(ITaskModel taskModel) {
+        ValueChangeStatistics statistics = new ValueChangeStatistics();
+        
+        calculateStatistics(taskModel.getTasks(), statistics);
+
+        statistics.condenseCheckBoxGroups();
+        
+        UsabilityEvaluationResult results = new UsabilityEvaluationResult(taskModel);
+        analyzeStatistics(statistics, taskModel, results);
+
+        return results;
+    }
+
+    /**
+     *
+     */
+    private void analyzeStatistics(ValueChangeStatistics     statistics,
+                                   ITaskModel                taskModel,
+                                   UsabilityEvaluationResult results)
+    {
+        Map<IGUIElement, List<IGUIElement>> checkBoxGroups = statistics.getCheckBoxGroups();
+        
+        CHECK_NEXT_GROUP:
+        for (List<IGUIElement> group : checkBoxGroups.values()) {
+            Set<ITask> tasksUsingGroup = new HashSet<>();
+            
+            for (IGUIElement checkBox : group) {
+                Set<ITask> tasksUsingCheckBox = getTasksUsingCheckBox(checkBox, taskModel);
+                
+                for (ITask taskUsingCheckBox : tasksUsingCheckBox) {
+                    if (tasksUsingGroup.contains(taskUsingCheckBox)) {
+                        continue CHECK_NEXT_GROUP;
+                    }
+                    else {
+                        tasksUsingGroup.add(taskUsingCheckBox);
+                    }
+                }
+            }
+            
+            if (tasksUsingGroup.size() > 0) {
+                int eventCoverage = 0;
+                int allRecordedEvents = 0;
+                
+                for (ITask task : tasksUsingGroup) {
+                    if (task instanceof IEventTask) {
+                        eventCoverage +=
+                            taskModel.getTaskInfo(task).getMeasureValue(TaskMetric.EVENT_COVERAGE);
+                    }
+                }
+                
+                for (ITask task : taskModel.getTasks()) {
+                    if (task instanceof IEventTask) {
+                        allRecordedEvents +=
+                            taskModel.getTaskInfo(task).getMeasureValue(TaskMetric.EVENT_COVERAGE);
+                    }
+                }
+                
+                
+                UsabilitySmellIntensity intensity = UsabilitySmellIntensity.getIntensity
+                    ((int) (1000 * eventCoverage / allRecordedEvents), eventCoverage, -1);
+                    
+                if (intensity != null) {
+                    Map<String, Object> parameters = new HashMap<String, Object>();
+                    parameters.put("radioButtons", group);
+
+                    results.addSmell
+                        (intensity, UsabilitySmellDescription.CHECK_BOX_SINGLE_SELECTION,
+                         parameters);
+                }
+            }
+        }
+    }
+
+    /**
+     * 
+     */
+    private Set<ITask> getTasksUsingCheckBox(final IGUIElement checkBox, ITaskModel taskModel) {
+        final Set<ITask> tasksUsingCheckBox = new HashSet<ITask>();
+        
+        for (ITask candidate : taskModel.getTasks()) {
+            candidate.accept(new DefaultTaskTraversingVisitor() {
+                @Override
+                public void visit(IEventTask eventTask) {
+                    if (!eventTask.getInstances().isEmpty()) {
+                        IEventTaskInstance instance =
+                            (IEventTaskInstance) eventTask.getInstances().iterator().next();
+                        
+                        if (checkBox.equals(instance.getEvent().getTarget())) {
+                            tasksUsingCheckBox.add(eventTask);
+                        }
+                    }
+                }
+                
+                @Override
+                public void visit(IStructuringTemporalRelationship relationship) {
+                    if (tasksUsingCheckBox.contains(relationship)) {
+                        return;
+                    }
+                    else {
+                        for (ITask child : relationship.getChildren()) {
+                            if (tasksUsingCheckBox.contains(child)) {
+                                tasksUsingCheckBox.add(relationship);
+                                return;
+                            }
+                        }
+                        
+                        super.visit(relationship);
+                        
+                        for (ITask child : relationship.getChildren()) {
+                            if (tasksUsingCheckBox.contains(child)) {
+                                tasksUsingCheckBox.add(relationship);
+                                break;
+                            }
+                        }
+                    }
+                }
+
+                @Override
+                public void visit(IMarkingTemporalRelationship relationship) {
+                    if (tasksUsingCheckBox.contains(relationship)) {
+                        return;
+                    }
+                    else {
+                        if (tasksUsingCheckBox.contains(relationship.getMarkedTask())) {
+                            tasksUsingCheckBox.add(relationship);
+                            return;
+                        }
+                        
+                        super.visit(relationship);
+                        
+                        if (tasksUsingCheckBox.contains(relationship.getMarkedTask())) {
+                            tasksUsingCheckBox.add(relationship);
+                            return;
+                        }
+                    }
+                }
+            });
+        }
+        
+        return tasksUsingCheckBox;
+    }
+
+    /**
+     * 
+     */
+    private void calculateStatistics(Collection<ITask>     tasks,
+                                     ValueChangeStatistics statistics)
+    {
+        for (ITask task : tasks) {
+            if (task instanceof IEventTask) {
+                for (ITaskInstance taskInstance : task.getInstances()) {
+                    statistics.addValueChange((IEventTaskInstance) taskInstance);
+                }
+            }
+        }
+    }
+
+    /**
+     *
+     */
+    private static class ValueChangeStatistics {
+        
+        /** */
+        private Set<IGUIElement> checkBoxes = new HashSet<>();
+        
+        /** */
+        private Map<IGUIElement, List<IGUIElement>> checkBoxGroups = new HashMap<>();
+
+        /**
+         *
+         */
+        private void addValueChange(IEventTaskInstance instance) {
+            IGUIElement target = (IGUIElement) instance.getEvent().getTarget();
+            
+            if (target instanceof ICheckBox) {
+                checkBoxes.add(target);
+            }
+        }
+        
+        /**
+         *
+         */
+        private void condenseCheckBoxGroups() {
+            checkBoxGroups = RuleUtils.getGroups(checkBoxes, 3);
+        }
+
+        /**
+         *
+         */
+        private Map<IGUIElement, List<IGUIElement>> getCheckBoxGroups() {
+            return checkBoxGroups;
+        }
+
+    }
+
+}
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/CommonTaskRateRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/CommonTaskRateRule.java	(revision 1918)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/CommonTaskRateRule.java	(revision 1918)
@@ -0,0 +1,136 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.usability;
+
+import java.text.DecimalFormat;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.commons.math3.stat.descriptive.SummaryStatistics;
+
+import de.ugoe.cs.autoquest.tasktrees.treeifc.DefaultTaskInstanceTraversingVisitor;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IUserSession;
+
+/**
+ * TODO comment
+ * 
+ * @version $Revision: $ $Date: 16.07.2012$
+ * @author 2012, last modified by $Author: pharms$
+ */
+public class CommonTaskRateRule implements UsabilityEvaluationRule {
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.usability.UsabilityEvaluationRule#evaluate(TaskTree)
+     */
+    @Override
+    public UsabilityEvaluationResult evaluate(ITaskModel taskModel) {
+        SummaryStatistics statistics = new SummaryStatistics();
+        int allObserved = calculateStatistics(taskModel.getUserSessions(), statistics);
+
+        UsabilityEvaluationResult results = new UsabilityEvaluationResult(taskModel);
+        analyzeStatistics(statistics, allObserved, results);
+
+        return results;
+    }
+
+    /**
+     *
+     */
+    private void analyzeStatistics(SummaryStatistics         statistics,
+                                   int                       allObserved,
+                                   UsabilityEvaluationResult results)
+    {
+        // the mean should tend to 0.1 (all subsequent 10 actions are covered by the same task).
+        // The ratio must be similar, i.e., if the mean is 0.1 the ratio is 0, if the mean is 1.0
+        // the ratio is 1000
+        
+        if (statistics.getN() > 0) {
+            double mean = statistics.getMean();
+            int ratio = (int) (10000 * (mean - 0.1) / 9);
+
+            UsabilitySmellIntensity intensity =
+                UsabilitySmellIntensity.getIntensity(ratio, allObserved, -1);
+
+            if (intensity != null) {
+                Map<String, Object> parameters = new HashMap<String, Object>();
+                parameters.put("ratio", new DecimalFormat("#.##").format(mean * 10));
+
+                results.addSmell(intensity, UsabilitySmellDescription.COMMON_TASK_RATE, parameters);
+            }
+        }
+    }
+
+
+    /**
+     * 
+     */
+    private int calculateStatistics(List<IUserSession>      sessions,
+                                    final SummaryStatistics statistics)
+    {
+        final LinkedList<ITaskInstance> rootNodes = new LinkedList<>();
+        final List<IEventTaskInstance> leafNodes = new ArrayList<>();
+        
+        for (IUserSession session : sessions) {
+            rootNodes.clear();
+            
+            for (final ITaskInstance currentRoot : session) {
+                currentRoot.accept(new DefaultTaskInstanceTraversingVisitor() {
+                    @Override
+                    public void visit(IEventTaskInstance eventTaskInstance) {
+                        rootNodes.add(currentRoot);
+                        leafNodes.add(eventTaskInstance);
+
+                        if (rootNodes.size() >= 10) {
+                            statistics.addValue(getTaskCoverageMeasure(rootNodes));
+                            
+                            while (rootNodes.size() >= 10) {
+                                rootNodes.removeFirst();
+                            }
+                        }
+                    }
+                });
+            }
+        }
+        
+        return leafNodes.size();
+    }
+
+    /**
+     *
+     */
+    private double getTaskCoverageMeasure(LinkedList<ITaskInstance> rootNodes) {
+        int noOfDiffRoots = 0;
+        ITaskInstance prevRoot = null;
+        
+        for (ITaskInstance root : rootNodes) {
+            if (!root.equals(prevRoot)) {
+                noOfDiffRoots++;
+            }
+            
+            prevRoot = root;
+        }
+        
+        return (double) noOfDiffRoots / rootNodes.size();
+    }
+
+}
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/DataEntryMethodChangeRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/DataEntryMethodChangeRule.java	(revision 1918)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/DataEntryMethodChangeRule.java	(revision 1918)
@@ -0,0 +1,190 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.usability;
+
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.Map;
+
+import de.ugoe.cs.autoquest.eventcore.IEventType;
+import de.ugoe.cs.autoquest.eventcore.gui.KeyInteraction;
+import de.ugoe.cs.autoquest.eventcore.gui.MouseInteraction;
+import de.ugoe.cs.autoquest.eventcore.gui.Scroll;
+import de.ugoe.cs.autoquest.eventcore.gui.TextInput;
+import de.ugoe.cs.autoquest.eventcore.gui.TextSelection;
+import de.ugoe.cs.autoquest.eventcore.gui.ValueSelection;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.DefaultTaskInstanceTraversingVisitor;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ISequence;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITask;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
+
+/**
+ * TODO comment
+ * 
+ * @version $Revision: $ $Date: 16.07.2012$
+ * @author 2012, last modified by $Author: pharms$
+ */
+public class DataEntryMethodChangeRule implements UsabilityEvaluationRule {
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.usability.UsabilityEvaluationRule#evaluate(TaskTree)
+     */
+    @Override
+    public UsabilityEvaluationResult evaluate(ITaskModel taskModel) {
+        UsabilityEvaluationResult results = new UsabilityEvaluationResult(taskModel);
+
+        Map<ITask, Integer> smellingTasks = getDataEntryMethodChangeRatios(taskModel.getTasks());
+        analyzeDataEntryMethodChangeRatios(smellingTasks, results, taskModel);
+
+        return results;
+    }
+
+    /**
+     *
+     */
+    private void analyzeDataEntryMethodChangeRatios(Map<ITask, Integer>       smellingTasks,
+                                                    UsabilityEvaluationResult results,
+                                                    ITaskModel                taskModel)
+    {
+
+        for (Map.Entry<ITask, Integer> entry : smellingTasks.entrySet()) {
+            // data entry method change ratio of an instance is the sum of data entry method
+            // changes between subsequent events divided by the number of events minus one. The
+            // data entry method change ratio of a tasks is the average of the ratios of the
+            // instances. If this ratio is 0 no changes are done at all. If it is higher, it should
+            // be informed.
+            
+            UsabilitySmellIntensity intensity =
+                UsabilitySmellIntensity.getIntensity(entry.getValue(), entry.getKey(), taskModel);
+
+            if (intensity != null) {
+                Map<String, Object> parameters = new HashMap<String, Object>();
+
+                parameters.put("task", entry.getKey());
+                parameters.put("ratio", (float) entry.getValue() / 10);
+                
+                results.addSmell(entry.getKey(), intensity,
+                                 UsabilitySmellDescription.DATA_ENTRY_METHOD_CHANGE, parameters);
+            }
+        }
+    }
+
+    /**
+     * 
+     */
+    private Map<ITask, Integer> getDataEntryMethodChangeRatios(Collection<ITask> tasks) {
+        Map<ITask, Integer> impatienceRatios = new HashMap<ITask, Integer>();
+        
+        for (ITask task : tasks) {
+            if (task instanceof ISequence)  {
+                int ratio = getAverageDataEntryMethodChangeRatio((ISequence) task);
+                
+                if (ratio > 0) {
+                    impatienceRatios.put(task, ratio);
+                }
+            }
+        }
+        
+        return impatienceRatios;
+    }
+
+    /**
+     *
+     */
+    private int getAverageDataEntryMethodChangeRatio(ISequence task) {
+        if (task.getInstances().size() > 0) {
+            int cummulativeDataEntryMethodChangeRatio = 0;
+            for (ITaskInstance instance : task.getInstances()) {
+                cummulativeDataEntryMethodChangeRatio += getDataEntryMethodChangeRatio(instance);
+            }
+
+            return cummulativeDataEntryMethodChangeRatio / task.getInstances().size();
+        }
+        else {
+            return 0;
+        }
+    }
+
+    /**
+     *
+     */
+    private long getDataEntryMethodChangeRatio(ITaskInstance instance) {
+        final List<IEventTaskInstance> terminalNodes = new LinkedList<>();
+        
+        instance.accept(new DefaultTaskInstanceTraversingVisitor() {
+            @Override
+            public void visit(IEventTaskInstance eventTaskInstance) {
+                terminalNodes.add(eventTaskInstance);
+            }
+        });
+        
+        if (terminalNodes.size() > 1) {
+            IEventTaskInstance previous = null;
+            int changeCount = 0;
+
+            for (IEventTaskInstance current : terminalNodes) {
+                if (previous == null) {
+                    previous = current;
+                }
+                else if (dataEntryMethodChanges(previous, current)) {
+                    changeCount++;
+                }
+            }
+
+            return changeCount * 1000 / (terminalNodes.size() - 1);
+        }
+        else {
+            return 0;
+        }
+    }
+
+
+    /**
+     *
+     */
+    private boolean dataEntryMethodChanges(IEventTaskInstance first, IEventTaskInstance second) {
+        IEventType firstEventType = first.getEvent().getType();
+        IEventType secondEventType = second.getEvent().getType();
+        
+        boolean hasKeyboardInteraction =
+            isKeyboardInteraction(firstEventType) || isKeyboardInteraction(secondEventType);
+        
+        boolean hasMouseInteraction =
+            isMouseInteraction(firstEventType) || isMouseInteraction(secondEventType);
+        
+        return hasKeyboardInteraction && hasMouseInteraction;
+    }
+
+    /**
+     *
+     */
+    private boolean isKeyboardInteraction(IEventType eventType) {
+        return (eventType instanceof KeyInteraction) || (eventType instanceof TextInput);
+    }
+
+    /**
+     *
+     */
+    private boolean isMouseInteraction(IEventType eventType) {
+        return (eventType instanceof MouseInteraction) || (eventType instanceof ValueSelection) ||
+            (eventType instanceof TextSelection) || (eventType instanceof Scroll);
+    }
+}
Index: trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/DefaultCursorPositioningRule.java
===================================================================
--- trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/DefaultCursorPositioningRule.java	(revision 1918)
+++ trunk/autoquest-core-usability/src/main/java/de/ugoe/cs/autoquest/usability/DefaultCursorPositioningRule.java	(revision 1918)
@@ -0,0 +1,226 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
+package de.ugoe.cs.autoquest.usability;
+
+import java.text.DecimalFormat;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.commons.math3.stat.inference.ChiSquareTest;
+
+import de.ugoe.cs.autoquest.eventcore.Event;
+import de.ugoe.cs.autoquest.eventcore.IEventTarget;
+import de.ugoe.cs.autoquest.eventcore.gui.MouseButtonDown;
+import de.ugoe.cs.autoquest.eventcore.gui.MouseButtonInteraction;
+import de.ugoe.cs.autoquest.eventcore.gui.MouseClick;
+import de.ugoe.cs.autoquest.eventcore.gui.Scroll;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IGUIElement;
+import de.ugoe.cs.autoquest.eventcore.guimodel.IGUIView;
+import de.ugoe.cs.autoquest.eventcore.guimodel.ITextArea;
+import de.ugoe.cs.autoquest.eventcore.guimodel.ITextField;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.DefaultTaskInstanceTraversingVisitor;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTask;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IEventTaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskInstance;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.ITaskModel;
+import de.ugoe.cs.autoquest.tasktrees.treeifc.IUserSession;
+
+/**
+ * TODO comment
+ * 
+ * @version $Revision: $ $Date: 16.07.2012$
+ * @author 2012, last modified by $Author: pharms$
+ */
+public class DefaultCursorPositioningRule implements UsabilityEvaluationRule {
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see de.ugoe.cs.usability.UsabilityEvaluationRule#evaluate(TaskTree)
+     */
+    @Override
+    public UsabilityEvaluationResult evaluate(ITaskModel taskModel) {
+        FirstViewActionStatistics statistics = new FirstViewActionStatistics();
+        calculateStatistics(taskModel.getUserSessions(), statistics);
+
+        UsabilityEvaluationResult results = new UsabilityEvaluationResult(taskModel);
+        analyzeStatistics(statistics, results);
+
+        return results;
+    }
+
+    /**
+     *
+     */
+    private void analyzeStatistics(FirstViewActionStatistics statistics,
+                                   UsabilityEvaluationResult results)
+    {
+        for (Map.Entry<IGUIView, Map<IEventTask, Integer>> firstActions :
+                statistics.getFirstViewActions().entrySet())
+        {
+            long[] observed = new long[firstActions.getValue().size()];
+            long allObservedInView = 0;
+            long maxObserved = 0;
+            int i = 0;
+            IEventTask mostOftenDoneFirst = null;
+            
+            for (Map.Entry<IEventTask, Integer> firstAction : firstActions.getValue().entrySet()) {
+                observed[i++] = firstAction.getValue();
+                allObservedInView += firstAction.getValue();
+                
+                if (maxObserved < firstAction.getValue()) {
+                    maxObserved = firstAction.getValue();
+                    mostOftenDoneFirst = firstAction.getKey();
+                }
+            }
+            
+            double[] expected = new double[firstActions.getValue().size()];
+            double expectedFrequency =
+                ((double) statistics.getViewOpenedCount(firstActions.getKey())) / expected.length;
+            
+            for (i = 0; i < expected.length; i++) {
+                expected[i] = expectedFrequency;
+            }
+            
+            if ((allObservedInView > 1) &&
+                ((expected.length == 1) ||
+                 (new ChiSquareTest().chiSquareTest(expected, observed, 0.05))))
+            {
+                // values are not equally distributed.
+                    
+                UsabilitySmellIntensity intensity = UsabilitySmellIntensity.getIntensity
+                    ((int) (1000 * maxObserved / allObservedInView), (int) allObservedInView, -1);
+                        
+                if ((intensity != null) && isCursorPositioningAction(mostOftenDoneFirst)) {
+                    Map<String, Object> parameters = new HashMap<String, Object>();
+                    parameters.put("view", firstActions.getKey());
+                    parameters.put("textfield", getTarget(mostOftenDoneFirst));
+                    parameters.put("ratio", new DecimalFormat("#.##").format
+                                       (100.0 * maxObserved / allObservedInView));
+
+                    results.addSmell(intensity, UsabilitySmellDescription.MOST_OFTEN_DONE_FIRST,
+                                     parameters);
+                }
+            }
+        }
+    }
+
+
+    /**
+     *
+     */
+    private boolean isCursorPositioningAction(IEventTask task) {
+        Event event = ((IEventTaskInstance) task.getInstances().iterator().next()).getEvent();
+        return ((event.getType() instanceof MouseClick) ||
+                (event.getType() instanceof MouseButtonDown)) &&
+               (((MouseButtonInteraction) event.getType()).getButton() ==
+                   MouseButtonInteraction.Button.LEFT) &&
+               ((event.getTarget() instanceof ITextField) ||
+                (event.getTarget() instanceof ITextArea));
+    }
+
+    /**
+     *
+     */
+    private IEventTarget getTarget(IEventTask task) {
+        return ((IEventTaskInstance) task.getInstances().iterator().next()).getEvent().getTarget();
+    }
+
+    /**
+     * 
+     */
+    private void calculateStatistics(List<IUserSession>              sessions,
+                                     final FirstViewActionStatistics statistics)
+    {
+        final IGUIView[] currentView = new IGUIView[1];
+        
+        for (IUserSession session : sessions) {
+            for (final ITaskInstance currentRoot : session) {
+                currentRoot.accept(new DefaultTaskInstanceTraversingVisitor() {
+                    @Override
+                    public void visit(IEventTaskInstance eventTaskInstance) {
+                        // ignore scrolling to get something semantically helpful
+                        if ((eventTaskInstance.getEvent().getTarget() instanceof IGUIElement) &&
+                            (!(eventTaskInstance.getEvent().getType() instanceof Scroll)))
+                        {
+                            IGUIView view =
+                                ((IGUIElement) eventTaskInstance.getEvent().getTarget()).getView();
+                            
+                            if (((currentView[0] == null) && (view != null)) ||
+                                ((currentView[0] != null) && (!currentView[0].equals(view))))
+                            {
+                                currentView[0] = view;
+                                statistics.addFirstViewAction
+                                    (view, eventTaskInstance.getEventTask());
+                            }
+                        }
+                    }
+                });
+            }
+        }
+    }
+
+    /**
+     *
+     */
+    private class FirstViewActionStatistics {
+        
+        /** */
+        private Map<IGUIView, Map<IEventTask, Integer>> firstViewActions = new HashMap<>();
+        
+        /**
+         *
+         */
+        private void addFirstViewAction(IGUIView view, IEventTask action) {
+            Map<IEventTask, Integer> counterMap = firstViewActions.get(view);
+            
+            if (counterMap == null) {
+                counterMap = new HashMap<>();
+                firstViewActions.put(view, counterMap);
+            }
+            
+            Integer counter = counterMap.get(action);
+            
+            if (counter == null) {
+                counterMap.put(action, 1);
+            }
+            else {
+                counterMap.put(action, counter + 1);
+            }
+        }
+
+        /**
+         *
+         */
+        private Map<IGUIView, Map<IEventTask, Integer>> getFirstViewActions() {
+            return firstViewActions;
+        }
+
+        /**
+         *
+         */
+        private int getViewOpenedCount(IGUIView view) {
+            Map<IEventTask, Integer> counterMap = firstViewActions.get(view);
+            int count = 0;
+            
+            for (Integer counter : counterMap.values()) {
+                count += counter;
+            }
+            
+            return count;
+        }
+    }
+}
